# Guidelines for Contributing

Thank you for your time on Wechaty.

## How to [contribute](https://github.com/wechaty/wechaty/blob/master/CONTRIBUTING.md)

* Write a blog about Wechaty
* Create a tutorial for Wechaty
* Help expand the [wiki](https://github.com/wechaty/wechaty/wiki)
* Answer questions on the [issue](https://github.com/wechaty/wechaty/issues)
* Review [pull requests](https://github.com/wechaty/wechaty/pulls)
* Start [hacking on Wechaty](https://github.com/wechaty/wechaty/blob/master/CONTRIBUTING.md)

### Why contribute

As an open source product, Chatie thrives from contributions of community members. Whatever your skill set is, there is a lot you can do to help us make Chatie better! 
So start forking!

### Not sure where to start?

It's a myth that writing code is the only way to contribute to open source. Chatie community is open to new ideas and there are so many different ways to make valuable contributions. We have some ideas of how you can get started!

#### 1. Contribute Code

- Check out GitHub issues with the tags `good first issue`, `pull request welcome` or `help wanted`
- Write code examples for documentation
- Report a bug and work on resolving it
- Collaborate with others on building new features

**Tips:** 
If you want to add new features or change the API, please submit an issue first to make sure no one else is already working on the same thing and discuss the implementation and API details with maintainers and users by creating an issue. When everything is settled down, you can submit a pull request.

Make sure to add tests for your features and bugfixes and update the documentation (see below) before submitting your code!

#### 2. Contribute Support

- Fix typos in documentation
- Translate documentation to your local language
- Write tutorials and blog posts, see more: https://github.com/chatie/blog
- Answer questions on the Wechaty Developers Home or Github issues
- Organize Chatie meetups or user groups in your area

Contact rui@chatie.io to learn more

## Link to Wechaty

Contribute by marketing: Add **Powered by Wechaty** Badge to your Project Homepage:

[![Powered by Wechaty](https://img.shields.io/badge/Powered%20By-Wechaty-green.svg)](https://github.com/wechaty/wechaty)

### Markdown

```markdown
[![Powered by Wechaty](https://img.shields.io/badge/Powered%20By-Wechaty-green.svg)](https://github.com/wechaty/wechaty)
```

### Html

```html
<a href="https://github.com/wechaty/wechaty" target="_blank">
  <img src="https://img.shields.io/badge/Powered%20By-Wechaty-green.svg" alt="Powered by Wechaty" border="0">
</a>
```

## Bug Report

Contribute by feedback, make code robust.

## Feature Request

Contribute by make product suggestion.

## Pull Request

Please:
 
1. submit issue to describe the problem to get start
1. then send pull request as you need(with unit test & pass linting)
 
  ```bash
  $ npm run lint
  $ npm run test
  ```

1. and do not forget to reference the issue 

I built wechaty with pleasure because it can help others. help from you for wechaty will be very appreciated by the community.

Cheers!

Huan
